#include "aimtrans.h"

void at_sleeper_main(void *arg)
{
	at_login login = (at_login)arg;
	jid j = (jid)(login->from);
	jid from = (jid)(login->to);
    jpacket jp = (jpacket)(login->jp);

	log_debug(ZONE, "[AIM] Sleeping on %s\n", jid_full(j));
	pth_sleep(2);

	at_session_create(login->user, login->pass, j, from);

	pth_yield(NULL);

    xmlnode_free(jp->x);
	free(login);
	
	return;
}

int at_auth_user(xmlnode xp)
{
	char *name;
	char *pass;
    xmlnode res;
	session s;
	pth_attr_t attr;
	at_login login;
    jpacket jp;

	/* Just a backup */
    jp = jpacket_new(xp);
	
	if(jp->to->resource == NULL)
	{
		return at_buddy_add(jp);
	}

	res = (xmlnode)jid_xres(jp->to);

	name = xmlnode_get_attrib(res, "name");
	pass = xmlnode_get_attrib(res, "pass");

	log_debug(ZONE, "[AIM] Auth recevied for %s\n", xmlnode2str(res));

    if(jp == NULL || name == NULL || pass == NULL)
        return 0;

	s = at_session_find_by_jid(jp->from);
	if(s==NULL)
	{
		attr = pth_attr_new();
		pth_attr_set(attr, PTH_ATTR_JOINABLE, FALSE);
		login = malloc(sizeof(_at_login));
		login->user = name;
		login->pass = pass;
		login->from = jp->from;
		login->to = jp->to;
        login->jp = jp;
		pth_spawn(attr, (void *)at_sleeper_main, (void *)login);
		pth_attr_destroy(attr);
		pth_yield(NULL);
		/* Now handled via sleeper thread
		 * 
		 * s = at_session_create(name, pass, jp->from);
		 */
	}
	else
	{
		log_debug(ZONE, "[AIM] Dumbass is already online\n");
	}
    return 0;
}

void at_auth_subscribe(jid to, jid from, char *user, char *pass)
{
    /* Here we actually subscribe to the user */
    xmlnode x;
    spool s;
    
    x = xmlnode_new_tag("presence");
    
    /* convert from to be aim.foo.net/registered?name=foo&pass=bar */
    s=spool_new(xmlnode_pool(x));
    spooler(s,at_name,"/registered?name=",user,"&pass=",pass,s);
    log_debug(ZONE, "[AIM] Subscribing to %s presence\n", jid_full(to));
	
    xmlnode_put_attrib(x, "to", jid_full(to));
    xmlnode_put_attrib(x, "from", spool_print(s));
    xmlnode_put_attrib(x, "type", "subscribe");

    ehandler_send(ehandler_at, x, to->server);

    return;
}
