#include "aimtrans.h"

iqcb callbacks;

iqcb at_find_iqcb(const char *ns)
{
    iqcb cur;

    for(cur = callbacks; cur != NULL; cur = cur->next)
    {
        if(j_strcmp(cur->ns, ns) == 0)
            return cur;
    }

    return NULL;
}

int at_register_iqns(const char *ns, iqfunc_t cb, void *arg)
{
    iqcb cur;

    cur = at_find_iqcb(ns);
    if(cur)
    {
        cur->iqfunc = cb;
        cur->arg = arg;
    } else {
        cur = malloc(sizeof(_iqcb));
        cur->ns = strdup(ns);
        cur->iqfunc = cb;
        cur->arg = arg;
        cur->next = callbacks;
        callbacks = cur;
    }

    return;
}

int at_run_iqcb(const char *ns, jpacket jp)
{
    iqcb cb;

    cb = at_find_iqcb(ns);
    if(cb == NULL)
        return -1;
    
    return cb->iqfunc(jp, cb->arg);
}
