#include "aimtrans.h"

/* this is the main function if the listener is to manually connect to etherx via a socket */

char *at_name=NULL;
int at_port=5269;

ppdb PPDB;

int main(int argc, char *argv[])
{
    pth_event_t sigevt;
    sigset_t set;
    int help, sig, i, sz;
    char *c, *secret, *ip;

	/* This parses all of our options */
    help = 0;
    c = at_name = secret = ip = NULL;
    for(i = 1; i < argc; i++)
    {
        /* check for flags */
        c = argv[i] + 1;
        switch(*c)
        {
            case 'D':
				/* Turn on debug mode */
                etherx_debug();
                break;
            case 'e':
				/* Set etherx's address */
                ip = strdup(argv[++i]);
                break;
            case 's':
				/* Set etherx's secret */
                secret = strdup(argv[++i]);
                break;
			case 'n':
				/* Set the transport hostname REQUIRED */
				at_name = strdup(argv[++i]);
				break;
            case 'p':
                /* Port mainly for jabber 2 */
                at_port = atoi(argv[++i]);
                break;
            default:
                help = 1;
        }
    }
 
    if(help || at_name==NULL)
    {
        printf("Usage:\naimtrans -n name [-D] [-e 127.0.0.1] [-s secret]\n");
        exit(0);
    }

    log_init(LOGSTDERR, NULL);

    log_debug(ZONE, "Loading Transport");

    if(ip == NULL)
        ip = strdup("127.0.0.1");
    if(secret == NULL)
        secret = strdup("test");
    etherx_init(secret,ip);
    at_init();
    
    sigemptyset(&set);
    sigaddset(&set, SIGHUP);
    sigaddset(&set, SIGINT);
    sigaddset(&set, SIGTERM);
    pth_sigmask(SIG_UNBLOCK, &set, NULL);
    sigevt = pth_event(PTH_EVENT_SIGS, &set, &sig);
 
    log_debug(ZONE,"Main loop waiting");
    pth_wait(sigevt);
 
    log_error("aimtrans","Received KILL, shutting down");
    /* do graceful shutdown */
    pth_sleep(1); /* one last chance to make sure everyone is done */
    pth_kill();
    return 0;
}
