#include "aimtrans.h"
#include "iq.h"

int at_parse_packet(xmlnode x)
{
    jpacket jp;
    session s;
    xmlnode dupx;
    char *ns;
    int ret=0;

    jp = jpacket_new(x);
    s = at_session_find_by_jid(jp->from);
    if(s != NULL)
    {
        log_debug(ZONE, "Packet sent to session parser");
        at_psend(s->mp_to, jp);
        return 1;
    }

    switch(jp->type)
    {
        case JPACKET_IQ:
            if(NSCHECK(xmlnode_get_tag(jp->x, "query"),NS_REGISTER))
            {
                /* Register the user */
                return at_register(jp);
            }
            ns = xmlnode_get_attrib(xmlnode_get_tag(jp->x, "query"), "xmlns");
            ret = at_run_iqcb(ns, jp);
            if(ret < 0)
            {
                /* XXX We could dup here and then return 0... */
                jutil_error(jp->x, TERROR_NOTFOUND);
                ehandler_send(ehandler_at, jp->x, jp->from->server);
                return 1;
            }
            return ret;
        case JPACKET_S10N:
            return at_server_s10n(jp);
        case JPACKET_PRESENCE:
            return at_server_pres(jp);
        case JPACKET_MESSAGE:
            /* XXX What do we want to do with this beast?                 */
            /* XXX There is really no reason to message the server itself */
            /* XXX Probably just want to return an error here             */
            return 0;
        default:
            jutil_error(jp->x, TERROR_NOTACCEPTABLE);
            ehandler_send(ehandler_at, jp->x, jp->from->server);
            return 1;
    }

    return 0;
}
