#include "aimtrans.h"

session sessions = NULL;

void at_session_main(void *arg);

int at_rateresp(struct aim_session_t *sess, struct command_rx_struct *command, ...)
{
    char *buddylist;
    session s;

    s = sess->aux_data;


    switch(command->conn->type) {
        case AIM_CONN_TYPE_BOS: {
            /* this is the new buddy list */
            char buddies[] = "";
            /* this is the new profile */
            /* XXX Can we let people do this? */
            char profile[] = "";  

            aim_bos_ackrateresp(sess, command->conn); 
            aim_bos_reqpersonalinfo(sess, command->conn);
            aim_bos_reqlocaterights(sess, command->conn);
            /* XXX evaluate these again later */
            aim_bos_setprofile(sess, command->conn, profile, NULL, 
                               AIM_CAPS_CHAT);
                           /* XXX I want it all!
                           AIM_CAPS_BUDDYICON | AIM_CAPS_CHAT | 
                           AIM_CAPS_VOICE | AIM_CAPS_GETFILE | 
                           AIM_CAPS_SENDFILE | AIM_CAPS_IMIMAGE);
                           */
            aim_bos_reqbuddyrights(sess, command->conn);

            /* send the buddy list and profile (required, even if empty) */
            buddylist = at_buddy_buildlist(s, s->cur);
            if(buddylist==NULL)
            {
                log_debug(ZONE, "[AIM] We have a NULL buddylist");
                if(aim_bos_setbuddylist(sess, command->conn, buddies)<0)
                    log_debug(ZONE, "[AIM] Error setting buddylist!");
            } else {
                log_debug(ZONE, "[AIM] Setting buddylist: %s", buddylist);
                if(aim_bos_setbuddylist(sess, command->conn, buddylist)<0)
                    log_debug(ZONE, "[AIM] Error setting buddylist!");
                free(buddylist);
            }

            /* dont really know what this does */
            aim_addicbmparam(sess, command->conn);
            aim_bos_reqicbmparaminfo(sess, command->conn);  
  
            aim_bos_reqrights(sess, command->conn);  
            /* set group permissions -- all user classes */
            /* XXX evaluate these! */
            aim_bos_setgroupperm(sess, command->conn, AIM_FLAG_ALLUSERS);
            aim_bos_setprivacyflags(sess, command->conn, 
                                AIM_PRIVFLAGS_ALLOWIDLE|
                                AIM_PRIVFLAGS_ALLOWMEMBERSINCE);

            break;  
        }

        default: 
            log_debug(ZONE, "[AIM] got rate response for unhandled connection type %04x", command->conn->type);
            break;
    }

    return 1;
}

int at_bosrights(struct aim_session_t *sess, 
                 struct command_rx_struct *command, ...)
{
    unsigned short maxpermits, maxdenies;
    va_list ap;
    xmlnode x;
    session s;

    s = sess->aux_data;

    va_start(ap, command);
    maxpermits = va_arg(ap, unsigned short);
    maxdenies = va_arg(ap, unsigned short);
    va_end(ap);

    log_debug(ZONE, "[AIM] BOS rights: Max permit = %d / Max deny = %d\n", 
                  maxpermits, maxdenies);

    aim_bos_clientready(sess, command->conn);

    log_debug(ZONE, "[AIM] officially connected to BOS.");

    s->loggedin = 1;
    x = jutil_presnew(JPACKET__AVAILABLE, jid_full(s->cur), "Connected");
    xmlnode_put_attrib(x, "from", jid_full(s->from));
    ehandler_send(ehandler_at, x, s->cur->server);

    return 1;
}

int at_parse_login(struct aim_session_t *sess, 
                   struct command_rx_struct *command, ...)
{
    struct client_info_s info = {"Jabber AIM Transport", 
                                 4, 1, 2010, 
                                 "us", "en", 0x0004, 
                                 0x0000, 0x0000004b}; /* 4.1.2010 */
    unsigned char *key;
    va_list ap;
    session s;
  
    s = (session)sess->aux_data;
    va_start(ap, command);
    key = va_arg(ap, char *);
    va_end(ap);

    aim_send_login(sess,command->conn,s->screenname,s->password, &info, key);
 
    return 1;
}

int at_parse_authresp(struct aim_session_t *sess, 
                      struct command_rx_struct *command, ...)
{
    struct aim_conn_t *bosconn = NULL;

    printf("Screen name: %s\n", sess->logininfo.screen_name);

    /*
    * Check for error.
    */
    if (sess->logininfo.errorcode)
    {
        spool sp;
        xmlnode x;
        xmlnode body;
        char *errorstr;
        session s=(session)sess->aux_data;

        x = xmlnode_new_tag("message");
        xmlnode_put_attrib(x, "to", jid_full(s->cur));
        xmlnode_put_attrib(x, "from", jid_full(s->from));
        xmlnode_put_attrib(x, "type", "error");
        body = xmlnode_insert_tag(x, "body");

        sp = spool_new(xmlnode_pool(x));
        spooler(sp, "Error Code #%04x While Logging in to AIM\n",
                "Error URL: %s\0", sp);
        errorstr = pmalloc(xmlnode_pool(x), 200);
        snprintf(errorstr, 200, spool_print(sp), sess->logininfo.errorcode,
                 sess->logininfo.errorurl);
        xmlnode_insert_cdata(body, errorstr, strlen(errorstr));
        ehandler_send(ehandler_at, x, s->cur->server);

        s->loggedin = 0;
        s->exit_flag = 1;
        aim_conn_kill(sess, &command->conn);
        return 1;
    }

    aim_conn_kill(sess, &command->conn);
    bosconn = aim_newconn(sess, AIM_CONN_TYPE_BOS, sess->logininfo.BOSIP);
    /* XXX Handle these better so we actually return and free the threads */
    if (bosconn == NULL) {
        fprintf(stderr, "at: could not connect to BOS: internal error\n");
    } else if (bosconn->status & AIM_CONN_STATUS_CONNERR) {	
        fprintf(stderr, "at: could not connect to BOS\n");
        aim_conn_kill(sess, &bosconn);
    } else {
        aim_conn_setlatency(bosconn, 1);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_SPECIAL, 
                            AIM_CB_SPECIAL_CONNCOMPLETE, at_conncomplete, 0);
        aim_conn_addhandler(sess, bosconn, 0x0009, 0x0003, 
                            at_bosrights, 0);
        aim_conn_addhandler(sess, bosconn, 0x0001, 0x0007, 
                            at_rateresp, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_ACK, 
                            AIM_CB_ACK_ACK, NULL, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_GEN, 
                            AIM_CB_GEN_SERVERREADY, at_serverready, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_GEN, 
                            AIM_CB_GEN_RATEINFO, NULL, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_GEN, 
                            AIM_CB_GEN_REDIRECT, at_handleredirect, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_BUD, 
                            AIM_CB_BUD_ONCOMING, at_parse_oncoming, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_BUD, 
                            AIM_CB_BUD_OFFGOING, at_parse_offgoing, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_MSG, 
                            AIM_CB_MSG_INCOMING, at_parse_incoming_im, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_LOC, 
                            AIM_CB_LOC_ERROR, at_parse_locerr, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_MSG, 
                            AIM_CB_MSG_MISSEDCALL, at_parse_misses, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_GEN, 
                            AIM_CB_GEN_RATECHANGE, at_parse_ratechange, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_GEN, 
                            AIM_CB_GEN_EVIL, at_parse_evilnotify, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_MSG, 
                            AIM_CB_MSG_ERROR, at_parse_msgerr, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_LOC, 
                            AIM_CB_LOC_USERINFO, at_parse_userinfo, 0);
        /* XXX Future?
         * aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_MSG, 
                            AIM_CB_MSG_ACK, at_parse_msgack, 0);
         */

        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_CTN, 
                            AIM_CB_CTN_DEFAULT, aim_parse_unknown, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_SPECIAL, 
                            AIM_CB_SPECIAL_DEFAULT, aim_parse_unknown, 0);
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_GEN, 
                            AIM_CB_GEN_MOTD, at_parse_motd, 0);
        
        aim_conn_addhandler(sess, bosconn, AIM_CB_FAM_SPECIAL, 
                            AIM_CB_SPECIAL_CONNERR, at_parse_connerr, 0);
    
        aim_auth_sendcookie(sess, bosconn, sess->logininfo.cookie);
    }
    
    return 1;
}

int at_serverready(struct aim_session_t *sess, struct command_rx_struct *command, ...)
{
  switch (command->conn->type)
    {
    case AIM_CONN_TYPE_BOS:

      aim_setversions(sess, command->conn);
      aim_bos_reqrate(sess, command->conn); /* request rate info */

      break;

      /* XXX Future expansion */
/*    case AIM_CONN_TYPE_CHATNAV:
      fprintf(stderr, "faimtest: chatnav: got server ready\n");
      aim_conn_addhandler(sess, command->conn, AIM_CB_FAM_CTN, AIM_CB_CTN_INFO, faimtest_chatnav_info, 0);
      aim_bos_reqrate(sess, command->conn);
      aim_bos_ackrateresp(sess, command->conn);
      aim_chatnav_clientready(sess, command->conn);
      aim_chatnav_reqrights(sess, command->conn);

      break;
    case AIM_CONN_TYPE_CHAT:
      aim_conn_addhandler(sess, command->conn, AIM_CB_FAM_CHT, AIM_CB_CHT_USERJOIN, faimtest_chat_join, 0);
      aim_conn_addhandler(sess, command->conn, AIM_CB_FAM_CHT, AIM_CB_CHT_USERLEAVE, faimtest_chat_leave, 0);
      aim_conn_addhandler(sess, command->conn, AIM_CB_FAM_CHT, AIM_CB_CHT_ROOMINFOUPDATE, faimtest_chat_infoupdate, 0);
      aim_conn_addhandler(sess, command->conn, AIM_CB_FAM_CHT, AIM_CB_CHT_INCOMINGMSG, faimtest_chat_incomingmsg, 0);
      aim_bos_reqrate(sess, command->conn);
      aim_bos_ackrateresp(sess, command->conn);
      aim_chat_clientready(sess, command->conn);
      break;

    case AIM_CONN_TYPE_RENDEZVOUS: 
      break;
*/
    default:
      log_debug(ZONE, "faimtest: unknown connection type on Server Ready\n");
    }
  return 1;
}

int at_handleredirect(struct aim_session_t *sess, struct command_rx_struct *command, ...)
{
  va_list ap;
  int serviceid;
  char *ip;
  unsigned char *cookie;

  va_start(ap, command);
  serviceid = va_arg(ap, int);
  ip = va_arg(ap, char *);
  cookie = va_arg(ap, unsigned char *);
 
  switch(serviceid)
    {
    case 0x0007: /* Authorizer */
      {
	struct aim_conn_t *tstconn;
	/* Open a connection to the Auth */
	tstconn = aim_newconn(sess, AIM_CONN_TYPE_AUTH, ip);
	if ( (tstconn==NULL) || (tstconn->status >= AIM_CONN_STATUS_RESOLVERR) )
	  fprintf(stderr, "faimtest: unable to reconnect with authorizer\n");
	else
	  /* Send the cookie to the Auth */
	  aim_auth_sendcookie(sess, tstconn, cookie);

      }  
      break;
    case 0x000d: /* XXX ChatNav */
      {
	/*struct aim_conn_t *tstconn = NULL;
	tstconn = aim_newconn(sess, AIM_CONN_TYPE_CHATNAV, ip);
	if ( (tstconn==NULL) || (tstconn->status >= AIM_CONN_STATUS_RESOLVERR)) {
	  fprintf(stderr, "faimtest: unable to connect to chatnav server\n");
	  if (tstconn) aim_conn_kill(sess, &tstconn);
	  return 1;
	}
	aim_conn_addhandler(sess, tstconn, 0x0001, 0x0003, faimtest_serverready, 0);
	aim_auth_sendcookie(sess, tstconn, cookie);
	fprintf(stderr, "\achatnav: connected\n");*/
      }
      break;
    case 0x000e: /* Chat */
      {
	/*char *roomname = NULL;
	struct aim_conn_t *tstconn = NULL;

	roomname = va_arg(ap, char *);

	tstconn = aim_newconn(sess, AIM_CONN_TYPE_CHAT, ip);
	if ( (tstconn==NULL) || (tstconn->status >= AIM_CONN_STATUS_RESOLVERR))
	  {
	    fprintf(stderr, "faimtest: unable to connect to chat server\n");
	    if (tstconn) aim_conn_kill(sess, &tstconn);
	    return 1;
	  }		
	printf("faimtest: chat: connected\n");

	aim_chat_attachname(tstconn, roomname);

	aim_conn_addhandler(sess, tstconn, 0x0001, 0x0003, faimtest_serverready, 0);
	aim_auth_sendcookie(sess, tstconn, cookie);*/
      }
      break;
    default:
      printf("uh oh... got redirect for unknown service 0x%04x!!\n", serviceid);
      /* dunno */
    }

  va_end(ap);

  return 1;
}

int at_parse_ratechange(struct aim_session_t *sess, struct command_rx_struct *command, ...)
{
/* XXX Do we want to deal with this? */
/*  va_list ap;
  unsigned long newrate;
  
  va_start(ap, command); 
  newrate = va_arg(ap, unsigned long);
  va_end(ap);

  printf("faimtest: ratechange: %lu\n", newrate);
*/
  return 1;
}

int at_parse_motd(struct aim_session_t *sess, 
                  struct command_rx_struct *command, ...)
{
/* XXX Should we do the headline?
  static char *codes[] = {
    "Unknown",
    "Mandatory upgrade",
    "Advisory upgrade",
    "System bulletin",
    "Top o' the world!"};
  static int codeslen = 5;

  char *amsg;
  unsigned short id;
  va_list ap;
  char msg[1024];
  
  va_start(ap, command);
  id = va_arg(ap, unsigned short);
  msg = va_arg(ap, char *);
  va_end(ap);

  printf("faimtest: motd: %s (%d / %s)\n", msg, id, 
	 (id < codeslen)?codes[id]:"unknown");
*/
  return 1;
}

int at_parse_connerr(struct aim_session_t *sess, 
                     struct command_rx_struct *command, ...)
{
  va_list ap;
  unsigned short code;
  char *msg = NULL;
  session s;

  s = (session)sess->aux_data;
  ap = va_start(ap, command);
  code = va_arg(ap, unsigned short);
  msg = va_arg(ap, char *);
  va_end(ap);

  s->exit_flag = 1;
  aim_conn_kill(sess, &command->conn); /* this will break the main loop */

  return 1;
}

int at_flapversion(struct aim_session_t *sess, 
                   struct command_rx_struct *command, ...)
{

  log_debug(ZONE, "[AIM] using FLAP version %u\n", 
            aimutil_get32(command->data));

  return 1;
}

int at_conncomplete(struct aim_session_t *sess, 
                    struct command_rx_struct *command, ...)
{
  va_list ap;
  struct aim_conn_t *conn;

  va_start(ap, command);
  conn = va_arg(ap, struct aim_conn_t *);
  va_end(ap);
  
  if (conn)
    log_debug(ZONE, "[AIM] connection on %d completed\n", conn->fd);

  return 1;
}

session at_session_create(char *user, char *pword, jid j, jid from)
{
	thread t;
	session new;
	struct aim_conn_t *authconn = NULL;
    pth_attr_t attr;

	new = at_session_find_by_jid(j);
	if(new!=NULL)
	{
		log_debug(ZONE, "[AIM] The goober is already online");
		return NULL;
	}
	log_debug(ZONE, "[AIM] New session for %s using %s, jid set to %s\n", user, 
					pword, jid_full(j));
	t = thread_new();
	new = pmalloc(t->p, sizeof(_session));
    new->t = t;
	t->data = (void *)new;
	new->cur=jid_new(t->p, jid_full(j));
	new->from=jid_new(t->p, jid_full(from));
	new->ass.aux_data = (void *)new;
    new->p = t->p;
	new->mp_to = pth_msgport_create("aimsession_to");
	new->loggedin = 0;
	new->buddies = NULL;
	new->profile = NULL;
	new->exit_flag = 0;
    new->screenname = user;
    new->password = pword;

	aim_session_init(&new->ass, AIM_SESS_FLAGS_NONBLOCKCONNECT);
	new->ass.aux_data = (void *)new;
	authconn = aim_newconn(&new->ass, AIM_CONN_TYPE_AUTH, FAIM_LOGIN_SERVER);
	if(authconn == NULL)
	{
        xmlnode err;
        
        /* Let the user know */
        err = xmlnode_new_tag("message");
        xmlnode_put_attrib(err, "to", jid_full(new->cur));
        xmlnode_put_attrib(err, "type", "error");
        xmlnode_put_attrib(err, "from", jid_full(new->from));
        jutil_error(err, (terror){500, "Error connecting to aims authentication server"});
        ehandler_send(ehandler_at, err, new->cur->server);

        /* Break it down */
		log_error("[AIM]", "Error connecting to aims authentication server.\n");
        thread_free(new->t);
		return NULL;
	} 
	else if (authconn->fd == -1)
	{
        xmlnode err;
        
        /* Let the user know */
        err = xmlnode_new_tag("message");
        xmlnode_put_attrib(err, "to", jid_full(new->cur));
        xmlnode_put_attrib(err, "type", "error");
        xmlnode_put_attrib(err, "from", jid_full(new->from));
        
		if (authconn->status & AIM_CONN_STATUS_RESOLVERR)
        {
            jutil_error(err, (terror){500, "Could not resolve AIM authorizer"});
			log_error("[AIM]", "at: could not resolve authorizer name\n");
        }
	    else if (authconn->status & AIM_CONN_STATUS_CONNERR)
        {
            jutil_error(err, (terror){500, "Could not connect to AIM authorizer"});
			log_error("[AIM]", "at: could not connect to authorizer\n");
        }
        ehandler_send(ehandler_at, err, new->cur->server);

        /* Clean up and get out */
        aim_conn_kill(&new->ass, &authconn);
        thread_free(new->t);
	    return NULL;
    }
  	else
    {
        aim_conn_addhandler(&new->ass, authconn, AIM_CB_FAM_SPECIAL, 
                            AIM_CB_SPECIAL_FLAPVER, at_flapversion, 0);
        aim_conn_addhandler(&new->ass, authconn, AIM_CB_FAM_SPECIAL, 
                            AIM_CB_SPECIAL_CONNCOMPLETE, at_conncomplete, 0);
        aim_conn_addhandler(&new->ass, authconn, 0x0017, 0x0007, 
                            at_parse_login, 0);
        aim_conn_addhandler(&new->ass, authconn, 0x0017, 0x0003, 
                            at_parse_authresp, 0);
    
        aim_request_login(&new->ass, authconn, user);

    }
    /* Ok everything is good, link this into the chain */
	new->next = sessions;
	sessions = new;

    /* Setup our thread and start er up */
	attr = pth_attr_new();
	pth_attr_set(attr, PTH_ATTR_JOINABLE, FALSE);
	t->id = pth_spawn(attr, (void *)&at_session_main, (void *)t);
	pth_attr_destroy(attr);
    pth_yield(NULL);
	log_debug(ZONE, "[AIM] We started a new session thread\n");

	return new;
}
	
void at_session_main(void *arg)
{
	thread t = (thread)arg;
    session s = (session)(t->data);
	pth_event_t to,done,ring;
	jpq q;
	xmlnode x;
	struct aim_conn_t *waitingconn = NULL;
    int status;

	to = pth_event(PTH_EVENT_MSG, s->mp_to);

	/* Do stuff */
	log_debug(ZONE, "[AIM] In our main session\n");
	while ((waitingconn = _aim_select(&s->ass, to, &status)) >= 0)
    {
        log_debug(ZONE, "[AIM] Got data from the select: %d", status);
  
		if(s->exit_flag)
			break;

        switch(status)
        {
            case -1:
                /* There was an error */
                s->exit_flag = 1;
                break;
            case 0:
                /* Nothing to do */
                break;
            case 1:
			    log_debug(ZONE, "[AIM] Flushing outgoing queue\n");
    			aim_tx_flushqueue(&s->ass);
                break;
            case 2:
    		    if (aim_get_command(&s->ass, waitingconn) < 0)
                {
	    			/* XXX do something like send an error */
		    		log_debug(ZONE,"[AIM] connection error (type 0x%04x:0x%04x)\n", waitingconn->type, waitingconn->subtype);
                    aim_conn_kill(&s->ass, &waitingconn);
                    if (!aim_getconn_type(&s->ass, AIM_CONN_TYPE_BOS))
	                      log_debug(ZONE,"major connection error");
			    	s->exit_flag = 1;
    			}
	        	else
		    	{
			    	aim_rxdispatch(&s->ass);
    			}
                break;
            case 3:
                log_debug(ZONE, "[AIM] Looking for data on the mp %X",s->mp_to);
		        while(1)
        		{
		        	q = (jpq)pth_msgport_get(s->mp_to);
        			if(q == NULL)
                    {
                        log_debug(ZONE, "[AIM] Nothing more on the mp\n");
		        		break;
                    }
                    at_aim_session_parser(s, q->p);
        		} 
                break;
        }

		if(s->exit_flag)
			break;
    }

	/* Close up */
	log_debug(ZONE,"[AIM] Closing up a main thread\n");
	/* close up all connections, dead or no */
	/*XXX this is causing TONS of crashes
	 * I'm just taking it out for now
	 */
	/*while(1)
    {
        q = (jpq)pth_msgport_get(s->mp_to);
        if(q == NULL)
            break;
        if(q->p->type == JPACKET_MESSAGE)
			at_aim_session_deliver(s, q->p->x, q->p->to);
        else
            xmlnode_free(q->p->x);
    }*/
	x = jutil_presnew(JPACKET__UNAVAILABLE, jid_full(s->cur), "Disconnected");
	xmlnode_put_attrib(x, "from", jid_full(s->from));
	ehandler_send(ehandler_at, x, s->cur->server);

    pth_msgport_destroy(s->mp_to);
	pth_event_free(to, PTH_FREE_ALL);
  	aim_logoff(&s->ass);
        log_debug(ZONE,"[AIM] unlinking session");
	at_session_unlink(s);
    if(s->buddies)
        at_session_unlink_buddies(s);

	pth_yield(NULL);

    thread_free(t);

	return;
}

/* XXX Fix me! */
void at_aim_session_parser(session s, jpacket jp)
{
    char *name;
    xmlnode x;
    jid j; /* for ppdb check */
    int freed;

    log_debug(ZONE, "[AIM] Parsing Packet\n");
        
    switch(jp->type)
    {
        case JPACKET_IQ:
            if(NSCHECK(xmlnode_get_tag(jp->x, "query"),NS_REGISTER))
            {
                /* Register the user */
                freed = at_register(jp);
                break;
            }
            if(jp->subtype == JPACKET__GET)
            {
                if( j_strcmp( jp->iqns, "jabber:iq:version" ) == 0 )
                {
                    xmlnode iq, iqname;
                    log_debug(ZONE, "[AIM] Responding to version query\n");
                    iq = xmlnode_dup( jp->x );
                    xmlnode_put_attrib( iq, "to", jid_full(jp->from) );
                    xmlnode_put_attrib( iq, "from", jid_full(jp->to) );
                    xmlnode_put_attrib( iq, "type", "result" );
                    iqname = xmlnode_insert_tag( iq, "name" );
                    xmlnode_insert_cdata( iqname, "Jabber AIM Transport", -1);
                    ehandler_send( ehandler_at, iq, jp->from->server );
                    freed = 0;
                    break;
                }
                else if( j_strcmp( jp->iqns, "jabber:iq:time" ) == 0 )
                {
                    xmlnode iq;
                    log_debug(ZONE, "[AIM] Responding to time query\n");
                    iq = jutil_iqresult( jp->x );
                    xmlnode_put_attrib(iq,"to",jid_full(jp->from));
                    xmlnode_put_attrib(iq,"from",jid_full(jp->to));
                    xmlnode_insert_cdata( xmlnode_insert_tag( iq, "utc"),jutil_timestamp(),-1);
                    xmlnode_insert_cdata(xmlnode_insert_tag(iq,"tz"),"gmt",-1);
                    ehandler_send(ehandler_at,iq,jp->from->server);
                    freed = 0;
                    break;
                }
            } 
            freed = 0;
            break;
	    case JPACKET_MESSAGE:
            /* Put the message on the line for the session to handle */
            at_session_deliver(s, jp->x, jp->to);
            freed = 0;
            break;
        case JPACKET_S10N:
            /* Handle a S10N packet based on their subtype */
            log_debug(ZONE, "[AIM] We got a s10n packet");
            freed = at_session_s10n(jp);
            break;
		case JPACKET_PRESENCE:
            freed = at_session_pres(jp);
            break;
        default:
            /* XXX do more!? */
            jutil_error(jp->x, TERROR_NOTACCEPTABLE);
            ehandler_send(ehandler_at, jp->x, jp->from->server);
            freed = 1;
            break;
	}

    if(freed==0)
        xmlnode_free(jp->x);
}

void at_session_deliver(session s, xmlnode x, jid from)
{
    /* XXX We need to check for the XHTML version of the msg */
    char *body;

    body = UTF8_to_str(xmlnode_pool(x),xmlnode_get_tag_data(x, "body"));

    if(body == NULL || from->user == NULL)
        return;

    log_debug(ZONE, "[AIM] Sending a Message");
    aim_send_im(&s->ass, aim_getconn_type(&s->ass, AIM_CONN_TYPE_BOS), 
                from->user, 0, body);
    return;
}

void at_session_end(session s)
{
    s->exit_flag = 1;
    pth_msgport_put(s->mp_to, NULL);
    return;
}
	
void at_session_unlink(session s)
{
    session next;
    session prev;
	
    if(s == NULL)
        return;
        log_debug(ZONE, "[AIM] starting to unlink");

    for(prev=NULL,next = sessions;next != NULL; next = next->next)
    {
        if(jid_cmp(s->cur, next->cur)==0)
        {
            if(prev ==NULL)
            {
                prev=next->next;
			    sessions=prev;
            }
            else
				prev->next = next->next;
            log_debug(ZONE, "[AIM] Unlinked group %s\n", jid_full(next->cur));
            return;
        }
        prev = next;
    }

    return;
}

void at_session_unlink_buddies(session s)
{
    at_buddy cur, next;

    cur = s->buddies;
    while(cur != NULL)
    {
        next = cur->next;
        pool_free(cur->p);
        cur = next;
    }
}

void at_session_buddy_unlink(session s, char *user)
{
    at_buddy next;
    at_buddy prev;
	
    if(user == NULL || s == NULL)
        return;
    log_debug(ZONE, "[AIM] starting to unlink");

    for(prev=NULL,next = s->buddies;next != NULL; next = next->next)
    {
        if(j_strcmp(next->to->user, user)==0)
        {
            if(prev ==NULL)
            {
                prev=next->next;
                s->buddies=prev;
            }
            else
                prev->next = next->next;
            log_debug(ZONE,"[AIM] Unlinked buddy %s\n",jid_full(next->to));
            pool_free(next->p);
            return;
        }
        prev = next;
    }

    return;

}

session at_session_find_by_jid(jid j)
{
    session next;

    if(j == NULL || sessions == NULL)
        return NULL;

    for(next = sessions; next != NULL; next = next->next)
    {
        if(next!=NULL && next->cur != NULL)
            if(j_strcmp(j->user, next->cur->user)==0 && 
               j_strcmp(j->server, next->cur->server) == 0)
                return next;
    }
	
    return NULL;
}

struct aim_conn_t *_aim_select(struct aim_session_t *sess, 
                               pth_event_t ev, 
                               int *status)
{
    pth_event_t tst;
    struct aim_conn_t *cur;
    fd_set fds, wfds;
    int maxfd = 0;
    int i, haveconnecting = 0;

    faim_mutex_lock(&sess->connlistlock);
    if (sess->connlist == NULL) {
        faim_mutex_unlock(&sess->connlistlock);
        *status = -1;
        return NULL;
    }
    faim_mutex_unlock(&sess->connlistlock);


    FD_ZERO(&fds);
    FD_ZERO(&wfds);
    maxfd = 0;

    faim_mutex_lock(&sess->connlistlock);
    for (cur = sess->connlist; cur; cur = cur->next) {
        if (cur->status & AIM_CONN_STATUS_INPROGRESS) {
            FD_SET(cur->fd, &wfds);
            haveconnecting++;
        }
        FD_SET(cur->fd, &fds);
        if (cur->fd > maxfd)
            maxfd = cur->fd;
    }
    faim_mutex_unlock(&sess->connlistlock);
    
    /* 
    * If we have data waiting to be sent, return immediatly
    */
    if (!haveconnecting && (sess->queue_outgoing != NULL)) {
        *status = 1;
        return NULL;
    } 

    if ((i = pth_select_ev(maxfd+1, &fds, NULL, NULL, NULL, ev))>=1) {
        faim_mutex_lock(&sess->connlistlock);
        for (cur = sess->connlist; cur; cur = cur->next) {
            if (FD_ISSET(cur->fd, &fds) || 
                ((cur->status & AIM_CONN_STATUS_INPROGRESS) && 
                FD_ISSET(cur->fd, &wfds))) 
            {
	            *status = 2;
	            faim_mutex_unlock(&sess->connlistlock);
	            return cur;
            }
        }
        *status = 0; /* shouldn't happen */
    } else if ((i == -1) && (errno == EINTR))/* treat inerpts as a timeout */
        *status = 0;
    else
        *status = i; /* can be 0 or -1 */

    if(pth_event_occurred(ev))
    {
        /* Possible msgport event (should be, no timeout) */
        *status = 3;
        return (struct aim_conn_t *)1;
    }

    faim_mutex_unlock(&sess->connlistlock);
    return NULL;  /* no waiting or error, return */
}
